Subject: Re: Bare repositories in the working tree are a security risk

From: Taylor Blau <[email-masked]>
Date: Thu, 21 Apr 2022 15:09:06 -0400

On Thu, Apr 21, 2022 at 11:25:39AM -0700, Emily Shaffer wrote:
> On Fri, Apr 15, 2022 at 6:28 PM Taylor Blau <[email-masked]> wrote:
> >
> > On Fri, Apr 15, 2022 at 05:41:59PM -0700, Glen Choo wrote:
> > > * We want additional protection on the client besides `git fsck`; there are
> > >   a few ways to do this:
> >
> > I'm a little late to chime into the thread, but I appreciate you
> > summarizing some of the approaches discussed so far. Let me add my
> > thoughts on each of these in order:
> >
> > >   1. Prevent checking out an embedded bare repo.
> > >   2. Detect if the bare repo is embedded and refuse to work with it.
> > >   3. Detect if the bare repo is embedded and do not read its config/hooks, but
> > >      everything else still 'works'.
> > >   4. Don't detect bare repos.
> > >   5. Only detect bare repos that are named `.git` [1].
> > >
> > >   (I've responded with my thoughts on each of these approaches in-thread).
> >
> >   1. Likely disrupts too many legitimate workflows for us to adopt
> >      without designing some way to declare an embedded bare repository
> >      is "safe".
> >   2. Ditto.
> >   3. This seems the most promising approach so far. Similar to (1), I
> >      would also want to make sure we provide an easy way to declare a
> >      bare repository as "safe" in order to avoid permanently disrupting
> >      valid workflows that have accumulated over the past >15 years.
>
> I'd like to think a little more about how we want to determine that a
> bare repo isn't embedded - wantonly scanning up the filesystem for any
> gitdir above the current one is really expensive. When I tried that
> approach for the purposes of including some shared config between
> superproject and submodules, it slowed down the Git test suite by
> something like 3-5x. So, I suppose that "we think this is bare" means
> refs/ and objects/ present in a directory that isn't named '.git/',
> and then we hunt anywhere above us for another .git/? Of course being
> careful not to accept another bare repo as the "parent" gitdir.

Definitely worth considering. Fundamentally I think if you're going to
allow checking out embedded bare repositories (which I strongly think
that we should), any search for "is this repository embedded in another
one?" needs to walk along its entire path up to the filesystem root.

I'd think that we could offer some tools, perhaps "safe.boundary",
specifying a list of directories to halt our traversal at. IOW, if you
have a bunch of bare repositories underneath /data/repositories, and
know that they're all safe, you could set your boundary there to signal
to Git "if my path is a subdirectory of anything in safe.boundary, then
I don't care whether the repo is embedded or not".

> Does it work for submodules? I suppose it works for non-bare
> submodules - and for bare submodules, e.g.
> 'submodule-having-project.git/modules/some-submodule/' we can rely on
> the user to turn that flag on if they want their submodule's config
> and hooks to be noticed from the gitdir. (From
> 'worktree-for-submodule-having-project/some-submodule' there is a
> '.git' pointer, so I'd expect things to work normally that way,
> right?)

I don't enough about submodules to comment here, sorry.

> > Here's an alternative approach, which I haven't seen discussed thus
> > far: [...]
>
> Nice - a more strict spin on proposal 3 from above, if I understand it
> right. Rather than allowing any and all bare repos, avoid someone
> sneaking in a malicious one next to legitimate ones by using an
> allowlist. Seems reasonable to me.

We'd probably want to allow saying "all embedded bare repositories are
safe to read config/hooks from", too. I hadn't considered this approach
as a way to read some embedded repos and not others; I suspect the
overwhelmingly common use-case would be: `git config --local
safe.embeddedRepo '*'`.

Thanks,
Taylor